QuaZipNewInfo Struct Reference

Information about a file to be created. More...

`#include <quazipnewinfo.h>`

## Public Member Functions

| QuaZipNewInfo (const QString &name)
| Constructs QuaZipNewInfo instance.
| QuaZipNewInfo (const QString &name, const QString &file)
| Constructs QuaZipNewInfo instance.
| QuaZipNewInfo (const QString &name, const QString &file, const QDateTime &dateTime)
| Constructs QuaZipNewInfo instance.
| QuaZipNewInfo (const QuaZipFileInfo &existing)
| Initializes the new instance from existing file info.
| QuaZipNewInfo (const QuaZipFileInfo64 &existing)
| Initializes the new instance from existing file info.
void | setFileDateTime (const QString &file)
| Sets the file timestamp from the existing file.
void | setFilePermissions (const QString &file)
| Sets the file permissions from the existing file.
void | setPermissions (QFile::Permissions permissions)
| Sets the file permissions.
void | setFileNTFSTimes (const QString &fileName)
| Sets the NTFS times from an existing file.
void | setFileNTFSmTime (const QDateTime &mTime, int fineTicks=0)
| Sets the NTFS modification time.
void | setFileNTFSaTime (const QDateTime &aTime, int fineTicks=0)
| Sets the NTFS access time.
void | setFileNTFScTime (const QDateTime &cTime, int fineTicks=0)
| Sets the NTFS creation time.

## Public Attributes

QString | name
| File name.
QDateTime | dateTime
| File timestamp.
quint16 | internalAttr
| File internal attributes.
quint32 | externalAttr
| File external attributes.
QString | comment
| File comment.
QByteArray | extraLocal
| File local extra field.
QByteArray | extraGlobal
| File global extra field.
ulong | uncompressedSize
| Uncompressed file size.

## Detailed Description

Information about a file to be created.

This structure holds information about a file to be created inside ZIP archive. At least name should be set to something correct before passing this structure to QuaZipFile::open(OpenMode,const QuaZipNewInfo&,int,int,bool).

Zip64 support of this structure is slightly limited: in the raw mode (when a pre-compressed file is written into a ZIP file as-is), it is necessary to specify the uncompressed file size and the appropriate field is 32 bit. Since the raw mode is used extremely rare, there is no real need to have a separate QuaZipNewInfo64 structure like QuaZipFileInfo64. It may be added in the future though, if there is a demand for the raw mode with zip64 archives.

## Constructor & Destructor Documentation

## QuaZipNewInfo() [1/5]

QuaZipNewInfo::QuaZipNewInfo | ( | const QString & | name | ) |

Constructs QuaZipNewInfo instance.

Initializes name with name, dateTime with current date and time. Attributes are initialized with zeros, comment and extra field with null values.

## QuaZipNewInfo() [2/5]

QuaZipNewInfo::QuaZipNewInfo | ( | const QString & | name,
|  | const QString & | file
| ) |  |

Constructs QuaZipNewInfo instance.

Initializes name with name. Timestamp and permissions are taken from the specified file. If the file does not exists or its timestamp is inaccessible (e. g. you do not have read permission for the directory file in), uses current time and zero permissions. Other attributes are initialized with zeros, comment and extra field with null values.

See also
  setFileDateTime()

References dateTime.

## QuaZipNewInfo() [3/5]

QuaZipNewInfo::QuaZipNewInfo | ( | const QString & | name,
|  | const QString & | file,
|  | const QDateTime & | dateTime
| ) |  |

Constructs QuaZipNewInfo instance.

Initializes name with name and provided timestamp. Permissions are taken from the specified file. If the file does not exists or is inaccessible (e. g. you do not have read permission for the directory file in), uses zero permissions. Other attributes are initialized with zeros, comment and extra field with null values.

See also
  setFileDateTime()

## QuaZipNewInfo() [4/5]

QuaZipNewInfo::QuaZipNewInfo | ( | const QuaZipFileInfo & | existing | ) |

Initializes the new instance from existing file info.

Mainly used when copying files between archives.

Both extra fields are initialized to existing.extra.

QuaZipNewInfo

Parameters

  existing |

## QuaZipNewInfo() [5/5]

QuaZipNewInfo::QuaZipNewInfo | ( | const QuaZipFileInfo64 & | existing | ) |

Initializes the new instance from existing file info.

Mainly used when copying files between archives.

Both extra fields are initialized to existing.extra.

QuaZipNewInfo

Parameters

  existing |

## Member Function Documentation

## setFileDateTime()

void QuaZipNewInfo::setFileDateTime | ( | const QString & | file | ) |

Sets the file timestamp from the existing file.

Use this function to set the file timestamp from the existing file. Use it like this:

QuaZipFile zipFile(&zip);
QFile file("file-to-add");
file.open(QIODevice::ReadOnly);
QuaZipNewInfo info("file-name-in-archive");
info.setFileDateTime("file-to-add"); // take the timestamp from file
zipFile.open(QIODevice::WriteOnly, info);
QuaZipFile
A file inside ZIP archive.
Definition quazipfile.h:74
QuaZipNewInfo
Information about a file to be created.
Definition quazipnewinfo.h:50

This function does not change dateTime if some error occured (e. g. file is inaccessible).

References dateTime.

## setFilePermissions()

void QuaZipNewInfo::setFilePermissions | ( | const QString & | file | ) |

Sets the file permissions from the existing file.

Takes permissions from the file and sets the high 16 bits of external attributes. Uses QFileInfo to get permissions on all platforms.

## setPermissions()

void QuaZipNewInfo::setPermissions | ( | QFile::Permissions | permissions | ) |

Sets the file permissions.

Modifies the highest 16 bits of external attributes. The type part is set to dir if the name ends with a slash, and to regular file otherwise.

References name.

## setFileNTFSTimes()

void QuaZipNewInfo::setFileNTFSTimes | ( | const QString & | fileName | ) |

Sets the NTFS times from an existing file.

If the file doesn't exist, a warning is printed to the stderr and nothing is done. Otherwise, all three times, as reported by QFileInfo::lastModified(), QFileInfo::lastRead() and QFileInfo::birthTime() (>=Qt5.10) or QFileInfo::created(), are written to the NTFS extra field record.

The NTFS record is written to both the local and the global extra fields, updating the existing record if there is one, or creating a new one and appending it to the end of each extra field.

The microseconds will be zero, as they aren't reported by QFileInfo.

Parameters

  fileName |

References setFileNTFSaTime(), setFileNTFScTime(), and setFileNTFSmTime().

## setFileNTFSmTime()

void QuaZipNewInfo::setFileNTFSmTime | ( | const QDateTime & | mTime,
|  | int | fineTicks = `0`
| ) |  |

Sets the NTFS modification time.

The time is written into the NTFS record in both the local and the global extra fields, updating the existing record if there is one, or creating a new one and appending it to the end of each extra field. When updating an existing record, all other fields are left intact.

Parameters

  mTime | The new modification time.
  fineTicks | The fractional part of milliseconds, in 100-nanosecond ticks (i. e. 9999 ticks = 999.9 microsecond). Values greater than 9999 will add milliseconds or even seconds, but this can be confusing and therefore is discouraged.

References extraGlobal, and extraLocal.

Referenced by setFileNTFSTimes().

## setFileNTFSaTime()

void QuaZipNewInfo::setFileNTFSaTime | ( | const QDateTime & | aTime,
|  | int | fineTicks = `0`
| ) |  |

Sets the NTFS access time.

The time is written into the NTFS record in both the local and the global extra fields, updating the existing record if there is one, or creating a new one and appending it to the end of each extra field. When updating an existing record, all other fields are left intact.

Parameters

  aTime | The new access time.
  fineTicks | The fractional part of milliseconds, in 100-nanosecond ticks (i. e. 9999 ticks = 999.9 microsecond). Values greater than 9999 will add milliseconds or even seconds, but this can be confusing and therefore is discouraged.

References extraGlobal, and extraLocal.

Referenced by setFileNTFSTimes().

## setFileNTFScTime()

void QuaZipNewInfo::setFileNTFScTime | ( | const QDateTime & | cTime,
|  | int | fineTicks = `0`
| ) |  |

Sets the NTFS creation time.

The time is written into the NTFS record in both the local and the global extra fields, updating the existing record if there is one, or creating a new one and appending it to the end of each extra field. When updating an existing record, all other fields are left intact.

Parameters

  cTime | The new creation time.
  fineTicks | The fractional part of milliseconds, in 100-nanosecond ticks (i. e. 9999 ticks = 999.9 microsecond). Values greater than 9999 will add milliseconds or even seconds, but this can be confusing and therefore is discouraged.

References extraGlobal, and extraLocal.

Referenced by setFileNTFSTimes().

## Member Data Documentation

## name

QString QuaZipNewInfo::name

File name.

This field holds file name inside archive, including path relative to archive root.

Referenced by QuaZipFile::open(), and setPermissions().

## dateTime

QDateTime QuaZipNewInfo::dateTime

File timestamp.

This is the last file modification date and time. Will be stored in the archive central directory. It is a good practice to set it to the source file timestamp instead of archive creating time. Use setFileDateTime() or QuaZipNewInfo(const QString&, const QString&).

Referenced by QuaZipFile::open(), QuaZipNewInfo(), and setFileDateTime().

## externalAttr

quint32 QuaZipNewInfo::externalAttr

File external attributes.

The highest 16 bits contain Unix file permissions and type (dir or file). The constructor QuaZipNewInfo(const QString&, const QString&) takes permissions from the provided file.

Referenced by QuaZipFile::open().

## comment

QString QuaZipNewInfo::comment

File comment.

Will be encoded in UTF-8 encoding.

Referenced by QuaZipFile::open().

## uncompressedSize

ulong QuaZipNewInfo::uncompressedSize

Uncompressed file size.

This is only needed if you are using raw file zipping mode, i. e. adding precompressed file in the zip archive.

Referenced by QuaZipFile::open().

The documentation for this struct was generated from the following files:

- quazip/quazipnewinfo.h
- quazip/quazipnewinfo.cpp